# Contributing

This is the issue tracker for Opal. If you have a more general question about
using opal (or related libraries) then use the
[google group for opal](http://groups.google.com/forum/#!forum/opalrb), or the
[#opal](http://webchat.freenode.net/?channels=opal) irc channel on
FreeNode.

## Contributing

1. Before opening a new issue, search for previous discussions including closed
ones. Add comments there if a similar issue is found.

2. Please report the version on which the issue is found.

3. Before sending pull requests make sure all tests run and pass (see below).

4. Make sure to use a similar coding style to the rest of the code base. In ruby
and javascript code we use 2 spaces (no tabs).

## Quick Start

Clone repo:

```
$ git clone git://github.com/opal/opal.git
```

Get dependencies:

```
$ bundle
```

Run the test suite:

```
$ bundle exec rake
```

See the [README](https://github.com/opal/opal/blob/master/README.md#running-tests) for further details.
