opal_filter "Object#frozen" do
  fails "Array#fill raises a RuntimeError on a frozen array"
  fails "Array#fill raises a RuntimeError on an empty frozen array"
  fails "Array#frozen? returns true if array is frozen"
  fails "Array#frozen? returns false for an array being sorted by #sort"
  fails "Array#unshift raises a RuntimeError on a frozen array when the array is modified"
  fails "Array#unshift raises a RuntimeError on a frozen array when the array would not be modified"
  fails "Array#uniq! doesn't yield to the block on a frozen array"
  fails "Array#uniq! raises a RuntimeError on a frozen array when the array would not be modified"
  fails "Array#uniq! raises a RuntimeError on a frozen array when the array is modified"
  fails "Array#sort! raises a RuntimeError on a frozen array"
  fails "Array#slice! raises a RuntimeError on a frozen array"
  fails "Array#shuffle! raises a RuntimeError on a frozen array"
  fails "Array#shift raises a RuntimeError on an empty frozen array"
  fails "Array#shift raises a RuntimeError on a frozen array"
  fails "Array#reverse! raises a RuntimeError on a frozen array"
  fails "Array#reject! raises a RuntimeError on an empty frozen array"
  fails "Array#reject! raises a RuntimeError on a frozen array"
  fails "Array#push raises a RuntimeError on a frozen array"
  fails "Array#pop passed a number n as an argument raises a RuntimeError on a frozen array"
  fails "Array#pop raises a RuntimeError on an empty frozen array"
  fails "Array#pop raises a RuntimeError on a frozen array"
  fails "Array#insert raises a RuntimeError on frozen arrays when the array would not be modified"
  fails "Array#insert raises a RuntimeError on frozen arrays when the array is modified"
  fails "Array#flatten! raises a RuntimeError on frozen arrays when the array would not be modified"
  fails "Array#flatten! raises a RuntimeError on frozen arrays when the array is modified"
  fails "Array#delete raises a RuntimeError on a frozen array"
  fails "Array#delete_if raises a RuntimeError on an empty frozen array"
  fails "Array#delete_if raises a RuntimeError on a frozen array"
  fails "Array#delete_at raises a RuntimeError on a frozen array"
  fails "Array#compact! raises a RuntimeError on a frozen array"
  fails "Array#clear raises a RuntimeError on a frozen array"
  fails "Array#<< raises a RuntimeError on a frozen array"
  fails "Array#[]= raises a RuntimeError on a frozen array"
  fails "Array#map! when frozen raises a RuntimeError when calling #each on the returned Enumerator when empty"
  fails "Array#map! when frozen raises a RuntimeError when calling #each on the returned Enumerator"
  fails "Array#map! when frozen raises a RuntimeError when empty"
  fails "Array#map! when frozen raises a RuntimeError"
  fails "Array#reject! returns an Enumerator if no block given, and the array is frozen"
  fails "Array#replace raises a RuntimeError on a frozen array"
  fails "Array#select! on frozen objects with truthy block keeps elements after any exception"
  fails "Array#select! on frozen objects with truthy block raises a RuntimeError"
  fails "Array#select! on frozen objects with falsy block keeps elements after any exception"
  fails "Array#select! on frozen objects with falsy block raises a RuntimeError"
  fails "Array#clone copies frozen status from the original"
  fails "Array#collect! when frozen raises a RuntimeError when calling #each on the returned Enumerator when empty"
  fails "Array#collect! when frozen raises a RuntimeError when calling #each on the returned Enumerator"
  fails "Array#collect! when frozen raises a RuntimeError when empty"
  fails "Array#collect! when frozen raises a RuntimeError"
  fails "Array#concat raises a RuntimeError when Array is frozen and modification occurs"
  fails "Array#concat raises a RuntimeError when Array is frozen and no modification occurs"
  fails "Array#delete_if returns an Enumerator if no block given, and the array is frozen"
  fails "Array#[]= checks frozen before attempting to coerce arguments"
  fails "Array#keep_if on frozen objects returns an Enumerator if no block is given"
  fails "Array#keep_if on frozen objects with truthy block keeps elements after any exception"
  fails "Array#keep_if on frozen objects with truthy block raises a RuntimeError"
  fails "Array#keep_if on frozen objects with falsy block keeps elements after any exception"
  fails "Array#keep_if on frozen objects with falsy block raises a RuntimeError"
  fails "Array#initialize raises a RuntimeError on frozen arrays"
  fails "Array#initialize_copy raises a RuntimeError on a frozen array"

  fails "Hash#clear raises a RuntimeError if called on a frozen instance"
  fails "Hash#default_proc= raises a RuntimeError if self is frozen"
  fails "Hash#initialize_copy raises a RuntimeError if called on a frozen instance that would not be modified"
  fails "Hash#initialize_copy raises a RuntimeError if called on a frozen instance that is modified"
  fails "Hash#initialize raises a RuntimeError if called on a frozen instance"
  fails "Hash#store raises a RuntimeError if called on a frozen instance"
  fails "Hash#store duplicates and freezes string keys"
  fails "Hash#default= raises a RuntimeError if called on a frozen instance"
  fails "Hash#delete raises a RuntimeError if called on a frozen instance"
  fails "Hash#delete_if raises a RuntimeError if called on a frozen instance"
  fails "Hash#[]= raises a RuntimeError if called on a frozen instance"
  fails "Hash#keep_if raises a RuntimeError if called on a frozen instance"
  fails "Hash#merge! raises a RuntimeError on a frozen instance that is modified"
  fails "Hash#merge! checks frozen status before coercing an object with #to_hash"
  fails "Hash#merge! raises a RuntimeError on a frozen instance that would not be modified"
  fails "Hash#reject! raises a RuntimeError if called on a frozen instance that is modified"
  fails "Hash#reject! raises a RuntimeError if called on a frozen instance that would not be modified"
  fails "Hash#reject! returns an Enumerator if called on a frozen instance"
  fails "Hash#replace raises a RuntimeError if called on a frozen instance that is modified"
  fails "Hash#replace raises a RuntimeError if called on a frozen instance that would not be modified"
  fails "Hash#select! raises a RuntimeError if called on an empty frozen instance"
  fails "Hash#select! raises a RuntimeError if called on a frozen instance that would not be modified"
  fails "Hash#shift raises a RuntimeError if called on a frozen instance"
  fails "Hash#update raises a RuntimeError on a frozen instance that would not be modified"
  fails "Hash#update checks frozen status before coercing an object with #to_hash"
  fails "Hash#update raises a RuntimeError on a frozen instance that is modified"
  fails "Hash#rehash raises a RuntimeError if called on a frozen instance"
  fails "Hash#[]= duplicates and freezes string keys"
end
